Cloudcli
======

Command line interface for interacting with Cloud providers. Useful as a helper for provisioning tools like Salt, Ansible, Terraform, that require region_id or image_id or any other API specific string.

## Installation

	pip install cloudcli

## Configuration

All sensitive data is stored in `~/.cloudcli/provider` in JSON

## Available providers 


### DigitalOcean 

A valid API V2 Read only token in `~/.cloudcli/digitalocean`


```
{
	"token": "read_only_token"
}
```


#### Available commands

- cloudcli-do list_images

```
{'distribution': u'CoreOS', 'id': '13388477', 'slug': u'coreos-beta', 'name': u'766.3.0 (beta)'}
{'distribution': u'CentOS', 'id': '6372321', 'slug': u'centos-5-8-x64', 'name': u'5.10 x64'}
{'distribution': u'CentOS', 'id': '6372425', 'slug': u'centos-5-8-x32', 'name': u'5.10 x32'}
{'distribution': u'Debian', 'id': '6372581', 'slug': u'debian-6-0-x64', 'name': u'6.0 x64'}
{'distribution': u'Debian', 'id': '6372662', 'slug': u'debian-6-0-x32', 'name': u'6.0 x32'}
....

```

- cloudcli-do list_sizes

```
{'id': '512mb', 'name': u'512mb'}
{'id': '1gb', 'name': u'1gb'}
{'id': '2gb', 'name': u'2gb'}
....
```

- cloudcli-do list_regions

```
{'id': 'nyc1', 'name': u'New York 1'}
{'id': 'ams1', 'name': u'Amsterdam 1'}
{'id': 'sfo1', 'name': u'San Francisco 1'}
....
```


### Amazon 


A valid access and secret key in `~/.cloudcli/amazon`


```
{
	"access_key_id": "access",
	"secret_access_key": "secret"
}
```


#### Available commands

- cloudcli-amazon list_images

```
{'id': 'ami-fef2ba96', 'name': 'bitnami-typo3-7.0.2-0-linux-ubuntu-14.04.1-x86_64-s3'}
{'id': 'ami-fef46c96', 'name': 'qbol-hvm-us-east-1-2014-12-02-125-33-43'}
{'id': 'ami-fefa7496', 'name': 'bitnami-rubystack-1.9.3-26-linux-ubuntu-14.04.1-x86_64-ebs'}
{'id': 'ami-fefb5096', 'name': 'ubuntu-14.04-docker-1.2.0-2014-09-22T00-04-18Z'}
{'id': 'ami-fefbe696', 'name': 'bitnami-phpbb-3.1.4-1-linux-ubuntu-14.04.1-x86_64-hvm-ebs'}

....

```

- cloudcli-amazon list_sizes

```
{'name': 'Micro Instance', 'id': 't1.micro'}
{'name': 'Small Instance', 'id': 'm1.small'}
{'name': 'Medium Instance', 'id': 'm1.medium'}
{'name': 'Large Instance', 'id': 'm1.large'}
....
```

- cloudcli-amazon list_regions - WIP

```
{'name': 'us-east-1a'}
{'name': 'us-east-1c'}
{'name': 'us-east-1d'}
{'name': 'us-east-1e'}
....